// C++ interface wrapper code.
//
// Generated by SIP v2.5 on Fri Aug 10 18:47:46 2001
//
// Terms and Conditions
// 
// Copyright (c) 1998, 1999, 2000, 2001
// 	Phil Thompson <phil@river-bank.demon.co.uk>
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// COPYRIGHT HOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
// IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// 
// Except as contained in this notice, the name of the copyright holder shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from the
// copyright holder.

#include "sipqtDeclqt.h"
#include "sipqtQEvent.h"


PyObject *sipClass_QEvent;

static void sipDealloc_QEvent(sipThisType *);

static PyTypeObject sipType_QEvent = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,
	sipName_qt_QEvent,
	sizeof (sipThisType),
	0,
	(destructor)sipDealloc_QEvent,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	Py_TPFLAGS_DEFAULT,
	0,
	0,
	0,
};

static PyObject *sipDo_QEvent_type(PyObject *sipThisObj,PyObject *sipArgs)
{
	sipThisType *sipThis;
	int sipArgsParsed = 0;

	if ((sipThis = sipGetThis(sipThisObj,&sipArgs,sipClass_QEvent)) == NULL)
		return NULL;

	{
		if (sipParseArgs(&sipArgsParsed,sipArgs,""))
		{
			QEvent::Type res;
			QEvent *ptr;

			if ((ptr = (QEvent *)sipGetCppPtr(sipThis,sipClass_QEvent)) == NULL)
				return NULL;

			res = ptr -> QEvent::type();

			return PyInt_FromLong((long)res);
		}
	}

	// Report an error if the arguments couldn't be parsed.

	sipNoMethod(sipArgsParsed,sipName_qt_QEvent,sipName_qt_type);

	return NULL;
}

// Convert to a sub-class if possible.

PyObject *sipSubClass_QEvent(const QEvent *sipCpp)
{
	PyObject *sipClass;
#line 556 "qevent.sip"
	extern PyObject
#if QT_VERSION > 300
		*sipClass_QContextMenuEvent, *sipClass_QIMEvent,
		*sipClass_QTabletEvent,
#endif
		*sipClass_QTimerEvent, *sipClass_QMouseEvent,
		*sipClass_QKeyEvent, *sipClass_QFocusEvent,
		*sipClass_QPaintEvent, *sipClass_QMoveEvent,
		*sipClass_QResizeEvent, *sipClass_QCloseEvent,
		*sipClass_QWheelEvent,
		*sipClass_QShowEvent, *sipClass_QHideEvent,
		*sipClass_QDragMoveEvent, *sipClass_QDragEnterEvent,
		*sipClass_QDragResponseEvent, *sipClass_QDragLeaveEvent,
		*sipClass_QDropEvent, *sipClass_QChildEvent,
		*sipClass_QCustomEvent;

	switch (sipCpp -> type())
	{
	case QEvent::Timer:
		sipClass = sipClass_QTimerEvent;
		break;

	case QEvent::MouseButtonPress:
	case QEvent::MouseButtonRelease:
	case QEvent::MouseButtonDblClick:
	case QEvent::MouseMove:
		sipClass = sipClass_QMouseEvent;
		break;

	case QEvent::KeyPress:
	case QEvent::KeyRelease:
		sipClass = sipClass_QKeyEvent;
		break;

	case QEvent::FocusIn:
	case QEvent::FocusOut:
		sipClass = sipClass_QFocusEvent;
		break;

	case QEvent::Paint:
		sipClass = sipClass_QPaintEvent;
		break;

	case QEvent::Move:
		sipClass = sipClass_QMoveEvent;
		break;

	case QEvent::Resize:
		sipClass = sipClass_QResizeEvent;
		break;

	case QEvent::Close:
		sipClass = sipClass_QCloseEvent;
		break;

	case QEvent::Wheel:
		sipClass = sipClass_QWheelEvent;
		break;

	case QEvent::Show:
		sipClass = sipClass_QShowEvent;
		break;

	case QEvent::Hide:
		sipClass = sipClass_QHideEvent;
		break;

	case QEvent::DragMove:
		sipClass = sipClass_QDragMoveEvent;
		break;

	case QEvent::DragEnter:
		sipClass = sipClass_QDragEnterEvent;
		break;

	case QEvent::DragResponse:
		sipClass = sipClass_QDragResponseEvent;
		break;

	case QEvent::DragLeave:
		sipClass = sipClass_QDragLeaveEvent;
		break;

	case QEvent::Drop:
		sipClass = sipClass_QDropEvent;
		break;

	case QEvent::ChildInserted:
	case QEvent::ChildRemoved:
		sipClass = sipClass_QChildEvent;
		break;

#if QT_VERSION > 300
	case QEvent::ContextMenu:
		sipClass = sipClass_QContextMenuEvent;
		break;

	case QEvent::IMStart:
	case QEvent::IMCompose:
	case QEvent::IMEnd:
		sipClass = sipClass_QIMEvent;
		break;

	case QEvent::Tablet:
		sipClass = sipClass_QTabletEvent;
		break;
#endif

	default:
		sipClass = (sipCpp -> type() < QEvent::User ?
				sipClass_QEvent :
				sipClass_QCustomEvent);
	}
#line 218 "sipqtQEvent.cpp"

	return sipClass;
}

// Cast a pointer to a type somewhere in its superclass hierachy.

const void *sipCast_QEvent(const void *ptr,PyObject *targetClass)
{
	const void *res;

	if (targetClass == sipClass_QEvent)
		return ptr;

	if ((res = sipCast_Qt((Qt *)(QEvent *)ptr,targetClass)) != NULL)
		return res;

	return NULL;
}

static void sipDealloc_QEvent(sipThisType *sipThis)
{
	if (sipThis -> u.cppPtr != NULL)
	{
		if (sipIsPyOwned(sipThis))
			delete (QEvent *)sipThis -> u.cppPtr;
	}

	sipDeleteThis(sipThis);
}

PyObject *sipNew_QEvent(PyObject *sipSelf,PyObject *sipArgs)
{
	static sipExtraType et = {
		sipCast_QEvent,
		(void *)sipNewProxy_qt,
		NULL
	};

	sipThisType *sipThis = NULL;
	const void *sipNew = NULL;
	int sipFlags = SIP_PY_OWNED;
	int sipArgsParsed = 0;

	// See if there is something pending.

	sipNew = sipGetPending(&sipFlags);

	if (sipNew == NULL)
	{
		long a0;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"-l",&a0))
		{
			sipNew = new QEvent( (QEvent::Type)a0);
		}
	}

	if (sipNew == NULL)
	{
		QEvent * a0;
		PyObject *a0obj;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"-I",sipCanConvertTo_QEvent,&a0obj))
		{
			int iserr = 0;

			sipConvertTo_QEvent(a0obj,&a0,1,&iserr);

			if (iserr)
				return NULL;

			sipNew = new QEvent(* a0);
		}
	}

	if (sipNew == NULL)
	{
		sipNoCtor(sipArgsParsed,sipName_qt_QEvent);
		return NULL;
	}

	// Wrap the object.

	if ((sipThis = sipCreateThis(sipSelf,sipNew,&sipType_QEvent,sipFlags,&et)) == NULL)
	{
		if (sipFlags & SIP_PY_OWNED)
			delete (QEvent *)sipNew;

		return NULL;
	}

	Py_INCREF(Py_None);
	return Py_None;
}

PyMethodDef sipClassAttrTab_QEvent[] = {
	{sipName_qt_type, sipDo_QEvent_type, METH_VARARGS, NULL},
	{NULL}
};

int sipCanConvertTo_QEvent(PyObject *sipPy)
{
	return sipIsSubClassInstance(sipPy,sipClass_QEvent);
}

void sipConvertTo_QEvent(PyObject *sipPy,QEvent **sipCppPtr,int sipWillDeref,int *sipIsErr)
{
	if (*sipIsErr || sipPy == NULL)
		return;

	if (sipPy == Py_None)
	{
		sipCheckNone(sipWillDeref,sipIsErr,sipName_qt_QEvent);
		*sipCppPtr = NULL;

		return;
	}

	*sipCppPtr = (QEvent *)sipConvertToCpp(sipPy,sipClass_QEvent,sipIsErr);
}

QEvent *sipForceConvertTo_QEvent(PyObject *valobj,int *iserrp)
{
	if (*iserrp || valobj == NULL || valobj == Py_None)
		return NULL;

	if (sipCanConvertTo_QEvent(valobj))
	{
		QEvent *val;

		sipConvertTo_QEvent(valobj,&val,0,iserrp);

		return val;
	}

	sipBadClass(sipName_qt_QEvent);

	*iserrp = 1;

	return NULL;
}
